function [ F ] = find_tight_sqrt( H, m, p, inds )
% This is an internal function used by the function 
% opt_measurements_mat

% 
% You are very welcome to use this code. For this, clearly acknowledge 
% the source of this code, and cite the paper that describes the algorithm:
% M. Mordechay and Y. Y. Schechner, "Matrix optimization for poisson compressed
% sensing," in Proceedings of IEEE GlobalSIP, December 2014, pp.684-688.
%
% (c) Copyright Moran Mordechay 2014. The matlab code is available for 
% non-commercial use and exploration.  For commercial use contact the
% author. The author is not liable for any damages or loss that might be 
% caused by use or connection to this code. 



[V,D] = eig(H);
D = rot90(D, 2);
% D = flipud(D);
% D = fliplr(D);
V = fliplr(V);

d = D(inds);
d(p+1:m) = 0;
inds_neg = d < 0;
d(inds_neg) = 0;
D(inds) = d;

D_new = zeros(p, p);
V_new = zeros(m, p);
D_new(:, :) = D(1:p, 1:p);
V_new(:, :) = V(:, 1:p);

D_half = sqrt(D_new);
S = D_half * V_new';

alpha = m / p;
F = sqrt(alpha) * V_new';

end

