function [ A_out ] = normalize_col_sum( A )

% This function normalizes the columns of a matrix to satisfy energy
% conservation, i.e. normalizes the sum of elements in each column to be 1.
% 
% You are very welcome to use this code. For this, clearly acknowledge 
% the source of this code, and cite the paper that describes the algorithm:
% M. Mordechay and Y. Y. Schechner, "Matrix optimization for poisson compressed
% sensing," in Proceedings of IEEE GlobalSIP, December 2014, pp.684-688.
%
% (c) Copyright Moran Mordechay 2014. The matlab code is available for 
% non-commercial use and exploration.  For commercial use contact the
% author. The author is not liable for any damages or loss that might be 
% caused by use or connection to this code. 


 s = sum(A);
 sum_rep = repmat(s, size(A, 1), 1);
 A_out = A ./ sum_rep;


end

